/**
 *  Copyright © 2025, Luis Andrés Lange <https://javacomm.net>
 *
 *  Previously released under Apache License 2.0; now licensed under MPL 2.0.
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;



public class PRIVATEMESSAGE extends MESSAGE implements Attachment {

  public final static String PSEUDOID = "PSEUDOID";
  public final static String REMOTE_PSEUDOID = "REMOTE_PSEUDOID";
  public final static String MESSAGE = "MESSAGE";
  public final static String DATETIME = "DATETIME";
  public final static String ROOM = "ROOM";
  public final static String CHATUSER = "CHATUSER";

  private String remotePseudoid;
  private String message;
  private String pseudoid;
  private Long datetime;
  /* die Nachricht kommt aus diesem Raum */
  private String room;
  // Chatuser enthält den Absender der Nachricht
  private ChatUser chatuser;

  // optional
  private Long attachment;
  private String filename;
  private Long filesize;

  @Override
  public Long getAttachment() {
    return attachment;
  }



  @Override
  public ChatUser getChatUser() {
    return chatuser;
  }



  @Override
  public Long getDatetime() {
    return datetime;
  }



  @Override
  public String getFilename() {
    return filename;
  }



  @Override
  public Long getFilesize() {
    return filesize;
  }



  @Override
  public String getMessage() {
    return message;
  }



  public String getPseudoid() {
    return pseudoid;
  }



  public String getRemotePseudoid() {
    return remotePseudoid;
  }



  @Override
  public String getRoom() {
    return room;
  }



  @Override
  public void setAttachment(Long number) {
    attachment = number;
  }



  @Override
  public void setChatUser(ChatUser value) {
    chatuser = value;
  }



  @Override
  public void setDatetime(Long value) {
    datetime = value;
  }



  @Override
  public void setFilename(String filename) {
    this.filename = filename;
  }



  @Override
  public void setFilesize(Long filesize) {
    this.filesize = filesize;
  }



  @Override
  public void setMessage(String value) {
    message = value;
  }



  /**
   * Dieser Anwender hat die Nachricht verschickt.
   * 
   * @param value
   *              die PSEUDOID vom Absender
   */
  public void setPseudoid(String value) {
    pseudoid = value;
  }



  public void setRemotePseudoid(String value) {
    remotePseudoid = value;
  }



  @Override
  public void setRoom(String value) {
    room = value;
  }



  @Override
  public String toString() {
    GsonBuilder builder = new GsonBuilder();
    builder.registerTypeAdapter(PRIVATEMESSAGE.class, new PrivateMessageSerializer())
        .registerTypeAdapter(ChatUser.class, new ChatUserSerializer());
    Gson gson = builder.create();
    return gson.toJson(this);
  }

}
